#include "MySqlCon.h"
#include <boost/lexical_cast.hpp>
#include <fstream>
#include <Wt/WApplication>
#include "ConfigureManager.h"
#include "ExceptionManager.h"

using namespace mysqlpp;

boost::mutex MySqlCon::mutex;
bool MySqlCon::bInitialized = false;
mysqlpp::Connection MySqlCon::con;


std::string MySqlCon::database = "RenderingMax";
std::string MySqlCon::server   = "localhost";
std::string MySqlCon::user     = "nick";
std::string MySqlCon::pass     = "202409";
int MySqlCon::port             = 3306;


bool MySqlCon::GetEnumTable(const std::string& strTableName, StringIntMap& nameIdMap)
{
    try
    {
        Query q = con.query();
        q << "select * from "<< strTableName;
        StoreQueryResult res = q.store();
        for (size_t i = 0; i < res.size(); i ++)
        {
            //Row row = res[i];
            //const String& name = row[1];
            nameIdMap[res[i][1].c_str()] = boost::lexical_cast<int>(res[i][0]);
        }
        return true;
    }
    catch (Exception e)
    {
        return false;
    }
}

int MySqlCon::VerifyUserPassword(const std::string& userName, const std::string& password)
{
    int nUserId = 0;
    try
    {
        Query q = con.query();
        q << "select UserId from Users where UserName="<<quote_only<<userName<<" and password="<<quote<<password;
        FILE_LOG(logDEBUG)<<"VerifyUserPassword:"<<q;
        StoreQueryResult res = q.store();
        if (res.size() == 1)
        {
            nUserId = boost::lexical_cast<int>(res[0][0]);
        }
    }
    catch (Exception e)
    {
        FILE_LOG(logERROR)<<"VerifyUserPassword failed";
    }
    return nUserId;
}

bool MySqlCon::RegisterUserPassword(const std::string& userName, const std::string& password, const std::string& email)
{
    try
    {
        Query q = con.query();
        q << "insert into Users(UserName, password, email)values("<<quote_only<<userName<<","<<quote_only<<password<<","<<quote_only<<email<<")";
        SimpleResult res = q.execute();
        return res.rows() == 1;
    }
    catch (Exception e)
    {
        return false;
    }
}

bool MySqlCon::GetDBConnectionInfo()
{
    /*
    std::ifstream dbconf((Wt::WApplication::appRoot() + "DBConnection.info").c_str());

    if (dbconf)
    {
        dbconf >> database;
        dbconf >> server;
        dbconf >> user;
        dbconf >> pass;
        dbconf >> port;
        return true;
    }
    return false;
    */
    try
    {
        database = CloudResourceManager::ConfigureManager::AppSettings("database");
        server = CloudResourceManager::ConfigureManager::AppSettings("server");
        user = CloudResourceManager::ConfigureManager::AppSettings("user");
        port = boost::lexical_cast<int>(CloudResourceManager::ConfigureManager::AppSettings("port"));
        return true;
    }
    catch(XmlException e)
    {
        return false;
    }
}


void MySqlCon::Initialize()
{
    mutex.lock();
    if (!bInitialized)
    {
        if (GetDBConnectionInfo())
        {
            con.connect(database.c_str(), server.c_str(), user.c_str(), pass.c_str(), port);
            con.set_option(new MultiStatementsOption(true));
            bInitialized = true;
        }
    }
    mutex.unlock();
}

MySqlCon::MySqlCon()
{
    Initialize();
}

