#ifndef MYSQLCON_H_INCLUDED
#define MYSQLCON_H_INCLUDED

#include <mysql++.h>
#include <boost/thread/mutex.hpp>
#include <map>

class MySqlCon
{
public:
    typedef std::map<std::string, int> StringIntMap;
    typedef StringIntMap::const_iterator StringIntMapIt;
    MySqlCon();
    bool GetEnumTable(const std::string& strTableName, StringIntMap& nameIdMap);
    int VerifyUserPassword(const std::string& userName, const std::string& password);
    bool RegisterUserPassword(const std::string& userName, const std::string& password, const std::string& email);
    static mysqlpp::Connection con;
private:
    static bool bInitialized;
    static boost::mutex mutex;
    void Initialize();
    static std::string database;
    static std::string server;
    static std::string user;
    static std::string pass;
    static int port;
    bool GetDBConnectionInfo();
};



#endif // MYSQLCON_H_INCLUDED
