#ifndef EMAILMANAGER_H_INCLUDED
#define EMAILMANAGER_H_INCLUDED

#include "stdafx.h"

using namespace std;

namespace CloudResourceManager
{
    namespace SECURITY_TYPE
    {
        enum
        {
            NO_SECURITY,
            USE_TLS,
            USE_SSL
        };
    }
    struct MailServerParam
    {
        string smtpServer;
        int port;
        int securityType;
    };

    struct MailUserParam
    {
        string loginUser;
        string password;
        string senderName;
        string senderEmail;
        string replyEmail;
    };
    struct MsgParam
    {
        StringVector recipients;
        StringVector ccRecipients;
        StringVector bccRecipients;
        string subject;
        string msg;
        StringVector attachments;
    };



    class EmailManager
    {
    public:
        bool SendMsg(const MsgParam& msgParam, const MailUserParam& mailUserParam, const MailServerParam& serverParam);
        bool SendHotmailMsg(const MsgParam& msgParam, const MailUserParam& mailUserParam);
        bool SendGmailMsgTLS(const MsgParam& msgParam, const MailUserParam& mailUserParam);
        bool SendGmailMsgSSL(const MsgParam& msgParam, const MailUserParam& mailUserParam);
        bool SendYahooMsg(const MsgParam& msgParam, const MailUserParam& mailUserParam);
        bool SendReportMail(const string& recipient, const string& subject, const string& msg);
    };

}


#endif
